import { NgModule } from '@angular/core';
import { HttpModule, JsonpModule, Http, XHRBackend, RequestOptions } from '@angular/http';
import { NextSessionService } from './session/next-session.service';
import { PermissionCheckerService } from './auth/permission-checker.service';
import { FeatureCheckerService } from './features/feature-checker.service';
import { LocalizationService } from './localization/localization.service';
import { SettingService } from './settings/setting.service';
import { NotifyService } from './notify/notify.service';
import { MessageService } from './message/message.service';
import { LogService } from './log/log.service';
import { NextMultiTenancyService } from './multi-tenancy/next-multi-tenancy.service';
import { NextHttpConfiguration, NextHttp } from './nextHttp';
import { NextUserConfigurationService } from './next-user-configuration.service';
import { TokenService } from './auth/token.service';
import { UtilsService } from './utils/utils.service';
export function nextHttpFactory(xhrBackend, requestOptions, configuration) {
    return new NextHttp(xhrBackend, requestOptions, configuration);
}
export var NEXT_HTTP_PROVIDER = {
    provide: Http,
    useFactory: nextHttpFactory,
    deps: [XHRBackend, RequestOptions, NextHttpConfiguration]
};
var NextModule = (function () {
    function NextModule() {
    }
    NextModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        HttpModule,
                        JsonpModule
                    ],
                    declarations: [],
                    providers: [
                        NextSessionService,
                        PermissionCheckerService,
                        FeatureCheckerService,
                        LocalizationService,
                        SettingService,
                        NotifyService,
                        MessageService,
                        LogService,
                        NextMultiTenancyService,
                        NextUserConfigurationService,
                        NextHttpConfiguration,
                        NEXT_HTTP_PROVIDER,
                        TokenService,
                        UtilsService
                    ]
                },] },
    ];
    /** @nocollapse */
    NextModule.ctorParameters = function () { return []; };
    return NextModule;
}());
export { NextModule };
//# sourceMappingURL=next.module.js.map